﻿Imports System.ComponentModel

Public Class Person : Inherits NotifyPropertyChanged

   Private _Name As String
   Public Property Name() As String
      Get
         Return _Name
      End Get
      Set(value As String)
         ChangePropIfDifferent(value, _Name)
      End Set
   End Property
   Private _Phone As String
   Public Property Phone() As String
      Get
         Return _Phone
      End Get
      Set(value As String)
         ChangePropIfDifferent(value, _Phone)
      End Set
   End Property
   Private _BirthDay As DateTime
   Public Property BirthDay() As DateTime
      Get
         Return _BirthDay
      End Get
      Set(value As DateTime)
         ChangePropIfDifferent(value, _BirthDay)
      End Set
   End Property
   Public Sub New()
   End Sub
   Public Sub New(name As String, phone As String, birth As DateTime)
      _Name = name
      _Phone = phone
      _BirthDay = birth
   End Sub

   Public Shared Function FromInt(i As Integer) As Person
      'to create TestData
      Return New Person("Person" & i, "54321" & i, DateTime.Today.AddYears(-60 + i))
   End Function


End Class
