﻿Imports System.Reflection
Imports System.ComponentModel, System.Runtime.CompilerServices

Namespace System.Windows.Controls
   Public Class SelectedItem


      Public Shared ReadOnly ItemSetterProperty As DependencyProperty = DependencyProperty.RegisterAttached("ItemSetter", GetType(Action(Of Object)), GetType(SelectedItem), New FrameworkPropertyMetadata(AddressOf ItemSetterCallback))

      'Public Shared ReadOnly ItemSetterProperty As DependencyProperty = New DepProp(AddressOf ItemSetterCallback)

      Private Shared Sub ItemSetterCallback( _
            sender As DependencyObject, e As DependencyPropertyChangedEventArgs)
         AddHandler DirectCast(sender, TreeView).SelectedItemChanged, AddressOf tvSelectedItemChanged
      End Sub

      Public Shared Function GetItemSetter(target As UIElement) As Action(Of Object)
         Return DirectCast(target.GetValue(ItemSetterProperty), Action(Of Object))
      End Function
      Public Shared Sub SetItemSetter(target As UIElement, value As Action(Of Object))
         target.SetValue(ItemSetterProperty, value)
      End Sub

      Private Shared Sub tvSelectedItemChanged(sender As Object, e As RoutedPropertyChangedEventArgs(Of Object))
         GetItemSetter(DirectCast(sender, TreeView)).Invoke(e.NewValue)
      End Sub

   End Class
End Namespace
