﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
ContextMenu-Behavior for TreeviewItem ListboxItem, for set the Item as selected on ContextMenu_Opened 
#End If
' -------------- Imports & Options --------------------
Imports System.Windows.Media
Imports System.ComponentModel, System.Runtime.CompilerServices
#End Region 'FileHeader

Namespace System.Windows.Controls

   Public Class SelectOnOpen : Inherits BehaviorBase(Of SelectOnOpen)
      Private WithEvents _Contextmenu As ContextMenu

      Protected Overrides Sub OnAttached(attachTarget As DependencyObject)
         _Contextmenu.TryBe(attachTarget)
      End Sub

      Private Sub _Contextmenu_Opened(sender As Object, e As RoutedEventArgs) Handles _Contextmenu.Opened
         Dim itm As DependencyObject = _Contextmenu.PlacementTarget
         Dim lbi As ListBoxItem = Nothing, tvi As TreeViewItem = Nothing
         While itm.NotNull
            itm = VisualTreeHelper.GetParent(itm)
            If lbi.TryBe(itm) Then
               lbi.IsSelected = True
            ElseIf tvi.TryBe(itm) Then
               tvi.IsSelected = True
            Else
               Continue While
            End If
            Return
         End While
      End Sub
   End Class
End Namespace
