﻿Imports System.Runtime.CompilerServices

Namespace System.Collections.Generic
   Public Module IEnumeratorX

#If True Then
      <DebuggerStepThrough(), Extension()> _
      Public Function Yield(Of T)(ByRef enrt As IEnumerator(Of T)) As T
         enrt.MoveNext()
         Return enrt.Current
      End Function
      ''' <summary>Exception on empty collection</summary>
      <DebuggerStepThrough(), Extension()> _
      Public Function YieldCyclic2(Of T)(ByRef enrt As IEnumerator(Of T)) As T
         With enrt
            If .MoveNext Then Return .Current
            .Reset() : .MoveNext() : Return .Current
         End With
      End Function
#ElseIf True Then
      <DebuggerStepThrough(), Extension()> _
      Public Function Yield(Of T)(enrt As IEnumerator(Of T)) As T
         'die Class-Einschränkung funzt net! List(Of T)-Enumeratoren sind Struct, und kommen dennoch hier an und machen Mist
         If TypeOf enrt Is ValueType Then Throw New InvalidOperationException("Yield-Extension: Enumerator must be class-type!")
         enrt.MoveNext()
         Return enrt.Current
      End Function

      ''' <summary>Exception on empty collection</summary>
      <DebuggerStepThrough(), Extension()> _
      Public Function YieldCyclic(Of T As Class)(enrt As IEnumerator(Of T)) As T
         'die Class-Einschränkung funzt net! List(Of T)-Enumeratoren sind Struct, und kommen dennoch hier an und machen Mist
         If TypeOf enrt Is ValueType Then Throw New InvalidOperationException("Yield-Extension: Enumerator must be class-type!")
         With enrt
            If .MoveNext Then Return .Current
            .Reset() : .MoveNext() : Return .Current
         End With
      End Function
#ElseIf True Then
#End If



      <DebuggerStepThrough(), Extension()> _
      Public Function Yield(enrt As IEnumerator) As Object
         'die Class-Einschränkung funzt net! List(Of T)-Enumeratoren sind Struct, und kommen dennoch hier an und machen Mist
         If TypeOf enrt Is ValueType Then Throw New InvalidOperationException("Yield-Extension: Enumerator must be class-type!")
         enrt.MoveNext()
         Return enrt.Current
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Function All(Of T)(enrt As IEnumerator(Of T), condition As Func(Of T, Boolean)) As Boolean
         While enrt.MoveNext
            If Not condition(enrt.Current) Then Return False
         End While
         Return True
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Function Any(Of T)(enrt As IEnumerator(Of T), condition As Func(Of T, Boolean)) As Boolean
         While enrt.MoveNext
            If condition(enrt.Current) Then Return True
         End While
         Return False
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Sub ForEach(Of T)(enrt As IEnumerator(Of T), Action As Action(Of T))
         While enrt.MoveNext : Action(enrt.Current) : End While
      End Sub

   End Module
End Namespace